Loading...
Searching...
No Matches
juce::SubregionStream Class Reference

`#include <juce_SubregionStream.h>`

Inheritance diagram for juce::SubregionStream:

## Public Member Functions

| SubregionStream (InputStream *sourceStream, int64 startPositionInSourceStream, int64 lengthOfSourceStream, bool deleteSourceWhenDestroyed)
| ~SubregionStream () override
int64 | getTotalLength () override
int64 | getPosition () override
bool | setPosition (int64 newPosition) override
int | read (void *destBuffer, int maxBytesToRead) override
bool | isExhausted () override
Public Member Functions inherited from juce::InputStream
virtual | ~InputStream ()=default
int64 | getNumBytesRemaining ()
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
virtual bool | readBool ()
virtual short | readShort ()
virtual short | readShortBigEndian ()
virtual int | readInt ()
virtual int | readIntBigEndian ()
virtual int64 | readInt64 ()
virtual int64 | readInt64BigEndian ()
virtual float | readFloat ()
virtual float | readFloatBigEndian ()
virtual double | readDouble ()
virtual double | readDoubleBigEndian ()
virtual int | readCompressedInt ()
virtual String | readNextLine ()
virtual String | readString ()
virtual String | readEntireStreamAsString ()
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
virtual void | skipNextBytes (int64 numBytesToSkip)

## Detailed Description

Wraps another input stream, and reads from a specific part of it.

This lets you take a subsection of a stream and present it as an entire stream in its own right.

Definition at line 34 of file juce_SubregionStream.h.

## Constructor & Destructor Documentation

## SubregionStream()

juce::SubregionStream::SubregionStream | ( | InputStream * | sourceStream,
|  | int64 | startPositionInSourceStream,
|  | int64 | lengthOfSourceStream,
|  | bool | deleteSourceWhenDestroyed )

Creates a SubregionStream from an input source.

Parameters

  sourceStream | the source stream to read from
  startPositionInSourceStream | this is the position in the source stream that corresponds to position 0 in this stream

  lengthOfSourceStream

  this specifies the maximum number of bytes from the source stream that will be passed through by this stream. When the position of this stream exceeds lengthOfSourceStream, it will cause an end-of-stream. If the length passed in here is greater than the length of the source stream (as returned by getTotalLength()), then the smaller value will be used. Passing a negative value for this parameter means it will keep reading until the source's end-of-stream.

  deleteSourceWhenDestroyed | whether the sourceStream that is passed in should be deleted by this object when it is itself deleted.

Definition at line 26 of file juce_SubregionStream.cpp.

## ~SubregionStream()

juce::SubregionStream::~SubregionStream | ( |  | ) |

override

Destructor.

This may also delete the source stream, if that option was chosen when the buffered stream was created.

Definition at line 36 of file juce_SubregionStream.cpp.

## Member Function Documentation

## getPosition()

int64 juce::SubregionStream::getPosition | ( |  | ) |

override virtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements juce::InputStream.

Definition at line 48 of file juce_SubregionStream.cpp.

Referenced by isExhausted(), and read().

## getTotalLength()

int64 juce::SubregionStream::getTotalLength | ( |  | ) |

override virtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements juce::InputStream.

Definition at line 40 of file juce_SubregionStream.cpp.

## isExhausted()

bool juce::SubregionStream::isExhausted | ( |  | ) |

override virtual

Returns true if the stream has no more data to read.

Implements juce::InputStream.

Definition at line 73 of file juce_SubregionStream.cpp.

## read()

int juce::SubregionStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead )

override virtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements juce::InputStream.

Definition at line 58 of file juce_SubregionStream.cpp.

## setPosition()

bool juce::SubregionStream::setPosition | ( | int64 | newPosition | ) |

override virtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements juce::InputStream.

Definition at line 53 of file juce_SubregionStream.cpp.

Referenced by SubregionStream().

The documentation for this class was generated from the following files:

- juce_SubregionStream.h
- juce_SubregionStream.cpp